function iniciarArduino
    
    % Crear la variable global a como 
    % un objeto arduino. Puerto COM5.
    global a;
    a=arduino('COM5');
    
    %Pines de PWM, direccin y los LEDs rojos
    pinPWM=[3 5 6 9 10 11];
    pinDireccion=[2 4 7 8 12 13];
    pinLed=[50 51 52];
    
    %Establecer los pines como salidas analogicas y digitales
    
    %Para los motores del 1 al 6
    for i=1:6
        %Establecer los pines como salidas digitales
        pinMode(a,pinDireccion(i),'output');
        %Poner las direcciones y los PWM a 0
        digitalWrite(a,pinDireccion(i),0);
        analogWrite(a,pinPWM(i),0);
    end
    
    %Secuencia de luces con los LEDs
    for i=1:3
        % Se establecen los pines de los LEDs
        % como salidas digitales
        pinMode(a,pinLed(i),'output');
        
        %Se encienden secuencialmente durante
        %1/4 de segundo y se apagan
        digitalWrite(a,pinLed(i),1);
        pause(0.25);
        digitalWrite(a,pinLed(i),0);
    end
    
    % Mantenmos el LED 1 encendido indicando que
    % que el Arduino est conectado.
     digitalWrite(a,pinLed(1),1);
     
     %Imprimimos por consola que el Arduino est conectado.
     fprintf('Arduino conectado\n');
end