% Esta funcin servir para posicionar los eslabones del robot
% a partir de los ngulos introducidos en grados.
function mover(num, val,PWM)
    % num : nmero del eslabn que se quiere mover
    %       adems,4 para rotacin de la mueca, 5 para giro
    % val : ngulo en grados
    % PWM : seal PWM del LMD18200 en tanto por uno
    

    % Llmamos a la variable global a
    global a
    
    % Encendemos el 2 LED rojo
    digitalWrite(a,51,1);
    
    % Iniciamos las dos variables globales pos4 y pos5
    % Estas variables contendran las dos posiciones de
    % la mueca en cada momento
    global pos4;
    global pos5;
    
    % Array con las reducciones de cada motor
    reduccion = [600 523.068 523.068 120 120];
    
    % Se calculan los pulsos correspondientes para el caso requerido
    pulsos = round(val/360*reduccion(num)*12);
    
    % Se seleccin el motor o motores a mover
    switch num
        
        % Rotacin de la base
        case 1
            
            % Se comprueba que el ngulo este dentro de los lmites
            if val>=-180 && val<=140
                %Se comprueba que el motor no este ya en
                %la posicin deseada
                if pulsos ~= encoder(1)
                    % En caso de no estarlo sel motor se mueve en la
                    % direccin necesaria.
                   if pulsos < encoder(1)
                       while pulsos < encoder(1)
                            motor(1,0,PWM);
                       end
                   else
                       while pulsos > encoder(1)
                            motor(1,1,PWM);
                       end
                   end
                end
            else 
                % Si el angulo no esta dentro de los lmite se imprime
                % en mensaje por pantalla.
                fprintf('ngulo no vlido\n');
            end
            % Se detiene el motor
            motor(1,0,0);
    

        %Giro del hombro
        case 2
            % Se necesita cambiar el signo de los pulsos
            pulsos = (-1)*pulsos;
            if val>=-30 && val<=120
                if pulsos ~= encoder(2)
                   if pulsos < encoder(2)
                       while pulsos < encoder(2)
                            motor(2,0,PWM);
                       end
                   else
                       while pulsos > encoder(2)
                            motor(2,1,PWM);
                       end
                   end
                end
            else 
                fprintf('ngulo no vlido\n');
            end
            motor(2,0,0);
            
        % Giro del codo
        case 3
            
            % Angulo mximo que puede girar
            q2 = encoder(2)*360/reduccion(2)/12;
            max = -0.00432864*q2^2+1.00469484*q2+64.2739366;
            if val>=-15 && val<=max
                if pulsos ~= encoder(3)
                   if pulsos < encoder(3)
                       while pulsos < encoder(3)
                            motor(3,0,1);
                       end
                   else
                       while pulsos > encoder(3)
                            motor(3,1,PWM);
                       end
                   end
                end
            else 
                fprintf('Angulo no vlido\n');
            end
            motor(3,0,0);
       
            
        %Giro de la mueca    
        case 4    
            % Se almacena el valor de los encoders en el momento inicial
            enc4 = (-1)*encoder(4);
            enc5 = encoder(5);
            
            % Se crean unas variables bandera con valor 1
            m4= 1;
            m5 = 1;
            
            % ngulo restringido entre 0 y 180
            if ang>=0 && ang<=180
            % Si se encuentra en una posicin distinta a la requerida
            if pulsos ~= pos4
                
                % Si el ngulo es menor
                if pulsos < pos4
                    
                    %Motores 4 y 5 con direccin 1
                    motor(4,1,PWM);
                    motor(5,1,PWM);

                    % Mientras alguna de las variable bandera sea 1
                    while m4 || m5
                       % Se almacena el incremento de los encoders
                       dif4 = (-1)*encoder(4) - enc4;
                       dif5 = encoder(5) - enc5;
                       
                       % Cuando un motor alcanza la posicin que se desea
                       %(posicion al inicio + la difencia) se para y se
                       %pone la bandera a 0.
                       if pulsos >= pos4 + dif4
                           motor(4,0,0);
                           m4 = 0;
                       end
                       if pulsos >= pos4 + dif5
                           motor(5,0,0);
                           m5 = 0;
                       end
                    end % fin del while 
                    
                %en caso contrario repetimos la misma secuencia
                %pero con los motores 4 y 5 con direccin 0.
                else
                    motor(4,0,PWM);
                    motor(5,0,PWM);

                    while m4 || m5
                       dif4 = (-1)*encoder(4) - enc4;
                       dif5 = encoder(5) - enc5;
                       if pulsos <= pos4 + dif4
                           motor(4,0,0);
                           m4 = 0;
                       end
                       if pulsos <= pos4 + dif5
                           motor(5,0,0);
                           m5 = 0;
                       end 

                    end % fin del while 
                end %fin del else
            end %fin del if
            else 
                fprintf('ngulo no vlido\n');
            end
            
            %Se actualiza la posicin
            pos4 = pulsos;
            
         %Rotacin de la mueca.
         case 5
             %En el case 5 se sigue el mismo procedimiento que en el 4
             %Salvo que la direccin de los motores 4 y 5 ser 0 y 1
             %1 y 0 respectivamente que la mueca gire sin rotacin.
            enc4 = encoder(4);
            enc5 = encoder(5);
            
            m4= 1;
            m5 = 1;
            
            if pulsos ~= pos5
                
                if pulsos < pos5
                    motor(4,0,PWM);
                    motor(5,1,PWM);


                    while m4 || m5
                       dif4 = encoder(4) - enc4;
                       
                       dif5 = encoder(5) - enc5;
                       
                       if pulsos >= pos5 + dif4
                           motor(4,0,0);
                           m4 = 0;
                       end
                       if pulsos >= pos5 + dif5
                           motor(5,0,0);
                           m5 = 0;
                       end
                    end % fin del while 
                    
                else
                    motor(4,1,PWM);
                    motor(5,0,PWM);

                    while m4 || m5
                       dif4 = encoder(4) - enc4;
                       dif5 = encoder(5) - enc5;
                       if pulsos <= pos5 + dif4
                           motor(4,0,0);
                           m4 = 0;
                       end
                       if pulsos <= pos5 + dif5
                           motor(5,0,0);
                           m5 = 0;
                       end 

                    end % fin del while 
                end %fin del else
            end %fin del if
            pos5 = pulsos;
       
 
    end % fin del switch
    
    % Se apaga el LED
    digitalWrite(a,51,0);
end